---
title: Links
slug: MDN/Editor/Links
tags:
  - Documentation
  - Guide
  - MDN
  - MDN Meta
  - editor
---
<div>{{MDNSidebar}}</div>

<p id="Creating_and_editing_links"><span class="seoSummary">Links are a crucial component to any wiki, not only among many documents, but within a single document, and MDN relies heavily on them. Fortunately, links are also very easy to create, even though there are <em>lots</em> of ways to make them!</span></p>

<div class="note">
<p><strong>Note:</strong> Please note that we have particular <a href="/en-US/docs/MDN/Contribute/Guidelines/Writing_style_guide#Links">preferred practices for linking</a>; these are described in the <a href="/en-US/docs/MDN/Contribute/Guidelines/Writing_style_guide">MDN writing style guide</a>.</p>
</div>

<h2 id="Using_the_toolbar">Using the toolbar</h2>

<p>The most obvious way to create a link is to click the "link" button in the toolbar, or press <kbd>Ctl</kbd>+<kbd>K</kbd> (<kbd>Command</kbd>-<kbd>K</kbd> on the Mac). The link button looks like this: <img alt="The link button (as of 2015-12-04)" src="https://mdn.mozillademos.org/files/12003/link-button.png" style="height: 16px; width: 16px;">. You can use this feature to create a link from scratch, or to add a link to existing, selected, text.</p>

<h3 id="Creating_a_link_from_scratch">Creating a link from scratch</h3>

<p>Once you've clicked on the link button, you'll be presented with the link editor dialog, seen below:</p>

<p><img alt="Screenshot of the Link dialog box, showing the Link Info tab" src="https://mdn.mozillademos.org/files/15289/link-info.png" style="border-style: solid; border-width: 1px; height: 320px; width: 335px;"></p>

<p>Here you can construct your new link. The controls in this dialog are:</p>

<dl>
 <dt>Link Type</dt>
 <dd>The type of link you're creating. The default, URL, is for a URL somewhere on the Web, either on MDN or off-site. You may also choose "Link to anchor in the text" or "Email". The anchor link option lets you link to an anchor you've previously inserted using the <strong>Anchor</strong> button in the toolbar, by choosing it from a list. The email option lets you configure a <code>mailto:</code> URL by entering the recipient's email address, subject, and default message content. You will almost always use the URL option.</dd>
 <dt>Article Title Lookup / Link Text</dt>
 <dd>This field serves two purposes: first, you can specify text that will be used as the link target (or, if you had selected text in the document before opening the dialog box, that text is displayed here as the link target), and second, the text entered here is used to look up articles on MDN that match what you enter, to find possible destination pages. For example, if you type "Array" in this box, you will see something like the following:<br>
 <img alt='Screenshot of the Link dialog box, showing a lookup menu for the text "Array"' src="https://mdn.mozillademos.org/files/15291/link%20dialog%20with%20lookup%20menu.png" style="border-style: solid; border-width: 1px; height: 388px; width: 496px;"></dd>
</dl>

<p>Here, you can see a list of all the pages on MDN whose titles include the text you've typed. You can then scroll through the list and select one of those pages, or keep typing to narrow down the list. Note that the items in the list display their locale ("[en-US]" in this case). That text is not used in the link target text; it is there to help you ensure that you are linking to an article in the same locale as the one you are editing.</p>
<dl>
 <dt>Attachments</dt>
 <dd>Alternatively, you may make the link be a link to one of the files attached to the current page by selecting the attachment from this list. This is a great way to offer links to download code samples and the like.</dd>
 <dt>URL</dt>
 <dd>Finally, the URL field lets you actually directly enter the URL; it also shows the URL of whatever you've selected in either the <strong>Article Title Lookup</strong> or <strong>Attachments</strong> menus, if you've used those. A common practice is to paste URLs to pages you're working on elsewhere on MDN. If you link to another article on MDN, remove the domain name ("https://developer.mozilla.org") from the beginning of the URL, since that's implied.</dd>
</dl>

<p>Once the link is configured, click the <strong>OK</strong> button to insert it.</p>

<div class="note">
<p>If you're paying attention, you'll see that there's a second tab—<strong>Advanced</strong>—in the link editor dialog. There are no options there that we advise you to use on a regular basis, at least at this time. It's possible that in the future there will be alternate styles for links, but we will likely add new toolbar widgets to use those features when they're available.</p>
</div>

<h3 id="Linking_existing_text">Linking existing text</h3>

<p>If you have existing text that you'd like to turn into a link, you can simplify the process somewhat. Highlight the text you'd like to turn into a link before opening the link editor; this will pre-populate the <strong>Article Title/Lookup Text</strong> field with the selected text. For example, let's say we have the following text:</p>

<blockquote>
<p>You may find it useful to use JavaScript arrays when working on this project.</p>
</blockquote>

<p>We'd like to turn "arrays" into a link to the appropriate content. Just highlight that word and invoke the link editor; you'll get a pre-populated dialog similar to the previous case. By "hovering" your mouse over a suggested article, you can see its relative slug (its URL relative to <code>developer.mozilla.org</code>), which can give you a better idea of where it is located and what type of article it is.</p>

<p><img alt="Screenshot of the Link dialog box, showing a lookup menu and a URL tooltip" src="https://mdn.mozillademos.org/files/15293/Rollover%20of%20lookup%20menu.png" style="border-style: solid; border-width: 1px; height: 387px; width: 493px;"></p>

<p>Here, of the articles suggested as possible matches. "Arrays" looks like a good choice, so we can choose that. This automatically fills in the URL field, so you can just click <strong>OK</strong> and the text gets turned into a link, like this:</p>

<blockquote>
<p>You may find it useful to use JavaScript <a href="/en-US/docs/Learn/JavaScript/First_steps/Arrays">arrays</a> when working on this project.</p>
</blockquote>

<h2 id="Using_link_macros">Using link macros</h2>

<p>MDN makes heavy use of <a href="/en-US/docs/Project:MDN/Contributing/Editor_guide#Using_macros">macros</a> to automatically create links to the appropriate content given a term, while also styling the link according to our style guide for you. Consider this: our style guide indicates that API term names, HTML elements and attributes, CSS properties, function names, and the like should be styled with the {{HTMLElement("code")}} element (just like that, in fact). They should also, usually, be links to the appropriate page on MDN.</p>

<p>Using macros to create these links takes a little getting used to but offers many benefits:</p>

<ul>
 <li>The appropriate styles are applied for you.</li>
 <li>The link is created for you—and is future-proofed against future changes in the way MDN is structured.</li>
 <li>Appropriate tooltips can be created for you, too.</li>
</ul>

<p>There are lots of these macros, and we won't look at them all here. Instead, we'll look at a few specific examples of the most common ones. For a more complete list, see the "<a href="/en-US/docs/Project:MDN/Contributing/Custom_macros#Creating_hyperlinks">Creating hyperlinks</a>" section in our <a href="/en-US/docs/Project:MDN/Contributing/Custom_macros">Custom macros for MDN</a> guide. It's worth noting that you can always look at the <a href="/en-US/docs/Project:Introduction_to_KumaScript">KumaScript</a> source code for any of these macros; most have comments at the top that explain how they work and what the various parameters are, if any.</p>

<h3 id="Linking_to_documentation_for_APIs">Linking to documentation for APIs</h3>

<p>We have a number of extremely helpful macros for creating styled links to APIs. Here are a few of the most useful ones; in each case, there may be added parameters available to give you more control over the output (such as suppressing the automatic addition of the <code>&lt;code&gt;</code> styling). Each macro name below can be clicked upon to read the macro code itself; they all have comments at the top explaining what they do and all of their parameters.</p>

<dl>
 <dt>{{TemplateLink("HTMLElement")}}</dt>
 <dd>Inserts an HTML element's name, properly styled and linked. For example: <code>\{{HTMLElement("table")}}</code> yields {{HTMLElement("table")}}.</dd>
 <dt>{{TemplateLink("cssxref")}}</dt>
 <dd>Inserts a CSS property, at-rule, or selector's documentation in the CSS reference. For example: <code>\{{cssxref("background-color")}}</code> results in {{cssxref("background-color")}}.</dd>
 <dt>{{TemplateLink("domxref")}}</dt>
 <dd>Inserts a link into the Web API Reference for a given API term. For example: <code>\{{domxref("window")}}</code> yields {{domxref("window")}} and <code>\{{domxref("window.scrollBy()")}}</code> inserts {{domxref("window.scrollBy()")}}. You can also supply an additional parameter to override the text: <code>\{{domxref("window.scrollBy", "scrollBy()")}}</code> results in {{domxref("window.scrollBy", "scrollBy()")}}.</dd>
 <dt>{{TemplateLink("SVGElement")}}</dt>
 <dd>Inserts an SVG element's name, properly styled and linked. For example: <code>\{{SVGElement("circle")}}</code> yields {{SVGElement("circle")}}.</dd>
</dl>

<h3 id="Linking_to_sections_in_the_same_article">Linking to sections in the same article</h3>

<p>To link to a section within the same article, you can use the {{TemplateLink("anch")}} macro. The syntax is straightforward: <code>\{{anch("Name of destination section")}}</code>. By default, the displayed link text is the title of that section, but you can add a second, optional, parameter indicating alternate text to use instead. Some examples:</p>

<ul>
 <li><code>\{{anch("Using the toolbar")}}</code> looks like this: {{anch("Using the toolbar")}}</li>
 <li><code>\{{anch("Using the toolbar", "earlier in this article")}}</code> looks like this: {{anch("Using the toolbar", "earlier in this article")}}</li>
</ul>

<h3 id="Linking_to_bugs">Linking to bugs</h3>

<p>You can link to a bug in Mozilla's Bugzilla database with the {{TemplateLink("bug")}} macro. This macro accepts a single parameter: the bug number to link to. For example, <code>\{{bug(765642)}}</code> looks like this: {{bug(765642)}}.</p>

<p>Similarly, you can create links to bugs in other browsers and Web engines:</p>

<dl>
 <dt>WebKit (Safari, etc.)</dt>
 <dd>{{TemplateLink("WebkitBug")}}: <code>\{{webkitbug(31277)}}</code> yields {{webkitbug(31277)}}.</dd>
</dl>

<h3 id="Linking_to_RFCs">Linking to RFCs</h3>

<p>Much of the way the Internet works at a core level is documented in RFCs. You can easily reference RFCs using the {{TemplateLink("RFC")}} macro. For example, \{{RFC(2616)}} becomes {{RFC(2616)}}. You can, optionally, also provide alternate link text to use instead of a selected piece of text from the article or and/or the section number within the specification to which to link.</p>

<h3 id="Linking_to_information_about_XPCOM_interfaces">Linking to information about XPCOM interfaces</h3>

<div class="note">
<p>The MDN staff no longer actively maintains the XPCOM documentation, but volunteer contributions are welcomel</p>
</div>

<p>If you're documenting Mozilla internals, being able to easily create links to XPCOM interface documentation is helpful. There are a few macros used for this.</p>

<p>The syntax for linking to the documentation for an XPCOM interface as a whole is just: <code>\{{interface("interfacename")}}</code>. For example, you might write:</p>

<blockquote>
<p>When you need to parse or create URIs, the \{{interface("nsIIOService")}} interface can help.</p>
</blockquote>

<p>The result looks like this:</p>

<blockquote>
<p>When you need to parse or create URIs, the {{interface("nsIIOService")}} interface can help.</p>
</blockquote>

<p>If you need to link to information about a specific method or attribute on an XPCOM interface, the {{TemplateLink("ifmethod")}} and {{TemplateLink("ifattribute")}} macros are for you. These accept as parameters the name of the interface and the name of the method or attribute to which you wish to reference. The {{TemplateLink("ifmethod")}} macro is particularly interesting, since it does some special formatting by adding the style guide-mandated parentheses after the method's name. For example, <code>\{{ifmethod("nsIIOService", "newURI")}}</code> results in {{ifmethod("nsIIOService", "newURI")}}. That's a case where you're being protected against possible changes in the style guide in the future!</p>

<h3 id="Linking_to_Mozilla_preference_documentation">Linking to Mozilla preference documentation</h3>

<p>To insert the name of a Mozilla preference and make it link to the corresponding page in the <a href="/en-US/docs/Mozilla/Preferences/Preference_reference">Preference reference</a>, use the {{TemplateLink("pref")}} macro. This accepts one parameter: the full name of the preference you wish to link to. For example, you can use <code>\{{pref("javascript.options.showInConsole")}}</code> to create this: {{pref("javascript.options.showInConsole")}}.</p>

<h3 id="Linking_to_a_Mozilla_source_file">Linking to a Mozilla source file</h3>

<p>You can link to files in Mozilla's source tree (although you probably won't do this often) using the {{TemplateLink("source")}} macro. Instead of specifying the full URL of the file, you can specify the path relative to the <code>/source/</code> directory. For example: \{{source("browser/Makefile.in")}} creates this link: {{source("browser/Makefile.in")}}.</p>

<p>You may also, optionally, specify alternative text to use for the link. For example, you can use \{{source("browser/Makefile.in", "the browser's makefile")}} to get the result: {{source("browser/Makefile.in", "the browser's makefile")}}.</p>

<div class="note">
<p>Please look at the {{anch("Using macros")}} documentation if you're interested in learning more about using macros, and check out our <a href="/en-US/docs/Project:MDN/Kuma/KumaScript_guide">KumaScript</a> documentation to learn more about the macro system itself.</p>
</div>

<h2 id="Linking_to_recommended_content">Linking to recommended content</h2>

<p>If you wish to create a list of related pages, or other recommended reading material, you should do so by creating a quicklinks box in the sidebar; this mechanism is replacing our old "See also" headings at the end of articles. For details on how to create quicklinks boxes, see <a href="/en-US/docs/MDN/Contribute/Structures/Quicklinks">Quicklinks</a>.</p>

<h2 id="URL_schemes">URL schemes</h2>

<p>For security reasons, you should only create links that use the following schemes:</p>

<ul>
 <li><code>http://</code></li>
 <li><code>https://</code></li>
 <li><code>ftp://</code></li>
 <li><code>mailto:</code></li>
</ul>

<p>Others may or may not work, but are not supported and will probably be removed by editorial staff.</p>

<div class="note">
<p>Special URL schemes such as <code>about:</code> and <code>chrome:</code> are used by Firefox, Google Chrome, and some other browsers to provide access to special content such as preferences, debugging information, and so forth. These links do not work from article content, so please do not try to create links using these schemes within MDN articles. The same applies to the <code>javascript:</code> and <code>jar:</code> schemes, which are blocked by most modern browsers as a security precaution.</p>
</div>

<p>{{EditorGuideQuicklinks}}</p>
